=== debian/changelog ===
drogon (1.9.11+ds-1) unstable; urgency=medium

  * New upstream release 1.9.11+ds
  * d/copyright: Updated
  * d/control:
    - Bump Standards-Version to 4.7.2
    - Version trantor dependency to 1.5.24 at least
  * d/watch: move to v5

 -- Pierre-Elliott Bécue <peb@debian.org>  Sun, 21 Sep 2025 21:39:44 +0200

drogon (1.9.0+ds-2) unstable; urgency=medium

  * Fix changelog and add missing lintian override.

 -- Pierre-Elliott Bécue <peb@debian.org>  Sat, 24 Aug 2024 00:44:07 +0200
