=== debian/control ===
Source: drogon
Maintainer: Pierre-Elliott Bécue <peb@debian.org>
Section: web
Priority: optional
Build-Depends:
  chrpath,
  cmake,
  debhelper-compat (=13),
  dh-cmake,
  dh-cmake-compat (=1),
  doxygen,
  libbrotli-dev,
  libc-ares-dev,
  libhiredis-dev,
  libjsoncpp-dev,
  libmariadb-dev,
  libpq-dev,
  libsqlite3-dev,
  libtrantor-dev (>= 1.5.24),
  libyaml-cpp-dev,
  uuid-dev,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/drogon
Vcs-Git: https://salsa.debian.org/debian/drogon.git
Homepage: https://github.com/drogonframework/drogon
Rules-Requires-Root: no

Package: libdrogon1t64
Provides: ${t64:Provides}
Architecture: any
Section: libs
Breaks: libdrogon1 (<< ${source:Version})
Replaces: libdrogon1
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++14/17-based HTTP application framework library files
 Drogon can be used to easily build various types of web application server
 programs using C++.
 .
 Drogon is a cross-platform framework, It supports Linux, macOS, FreeBSD,
 OpenBSD, HaikuOS, and Windows. Its main features are described in its Readme.
 .
 This package provides the Drogon Library

Package: libdrogon-dev
Architecture: any
Section: libdevel
Depends: libdrogon1t64 (= ${binary:Version}), libtrantor-dev (>= 1.5.24), ${misc:Depends}
Description: C++14/17-based HTTP application framework development files
 Drogon can be used to easily build various types of web application server
 programs using C++.
 .
 Drogon is a cross-platform framework, It supports Linux, macOS, FreeBSD,
 OpenBSD, HaikuOS, and Windows. Its main features are described in its Readme.
 .
 This package provides the Drogon Library Development files

Package: drogon
Architecture: any
Depends: libdrogon1t64 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: C++14/17-based HTTP application framework
 Drogon can be used to easily build various types of web application server
 programs using C++.
 .
 Drogon is a cross-platform framework, It supports Linux, macOS, FreeBSD,
 OpenBSD, HaikuOS, and Windows. Its main features are described in its Readme.
 .
 This package provides the Drogon binaries
